Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/generic/src/console/console.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -76,8 +76,17 @@
 static parea_t klog_parea;
 
+static indev_t stdin_sink;
+static outdev_t stdout_source;
+
 static indev_operations_t stdin_ops = {
 	.poll = NULL
 };
 
+static void stdout_write(outdev_t *dev, wchar_t ch, bool silent);
+
+static outdev_operations_t stdout_ops = {
+	.write = stdout_write
+};
+
 /** Silence output */
 bool silent = false;
@@ -90,10 +99,29 @@
 {
 	if (stdin == NULL) {
-		stdin = malloc(sizeof(indev_t), FRAME_ATOMIC);
-		if (stdin != NULL)
-			indev_initialize("stdin", stdin, &stdin_ops);
+		indev_initialize("stdin", &stdin_sink, &stdin_ops);
+		stdin = &stdin_sink;
 	}
 	
 	return stdin;
+}
+
+void stdout_wire(outdev_t *outdev)
+{
+	if (stdout == NULL) {
+		outdev_initialize("stdout", &stdout_source, &stdout_ops);
+		stdout = &stdout_source;
+	}
+	
+	list_append(&outdev->link, &stdout->list);
+}
+
+static void stdout_write(outdev_t *dev, wchar_t ch, bool silent)
+{
+	link_t *cur;
+	
+	for (cur = dev->list.next; cur != &dev->list; cur = cur->next) {
+		outdev_t *sink = list_get_instance(cur, outdev_t, link);
+		sink->op->write(sink, ch, silent);
+	}
 }
 
